/*--------------------------------------------------------------------------
 *  Copyright (c) 2006-2012 Igor Daniloff.
 *      All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found in this directory.
 *------------------------------------------------------------------------*/

#ifndef DW_RS_SDK_IUNKNOWN_H_
#define DW_RS_SDK_IUNKNOWN_H_

#include "DwRsSDK_defs.H"

/**\file
   \~russian Поддержка объектов со включенными счетчиками ссылок для C++.
   \~english Support of objects with enabled reference counters for C++. \~
   */

DWRSSDK_BEGIN

#ifdef __cplusplus

/**\~russian Базовый объект поддержки объектов со включенными счетчиками ссылок.
\~english Base object for the support of objects with enabled reference counters. \~
 */
class IUnknown
{
public:
    virtual             ~IUnknown() {}

    /**\~russian увеличить счетчик ссылок на 1.
    \~english increase the reference counter by 1.  \~
       */
    virtual void         AddRef() =0;
    /**\~russian уменьшить счетчик ссылок на 1. Если счетчик становится равным 0, то удалить объект.
    \~english decrease the reference counter by 1. If the counter equals to 0, delete the object. \~
     */
    virtual void         Release() =0;
};

#endif

DWRSSDK_END

#endif
